/* $Id: ATM.java 2269 2013-12-01 02:33:37Z terescoj $ */

/**
 * Class to represent ATM which withdraws money from a bank
 * Written 11/26/99 by Kim Bruce
 * Changed 3/16/00 by Barbara Lerner
 * Introduced a random pause in the critical section to make interference more probable.
 * Changed 5/7/02 by Jim Teresco to include a longer delay to better see
 * what is happening
 * 
 * @author additional updates, Jim Teresco, Siena College, Spring 2011
 * Additional updates, CSC 252, The College of Saint Rose, Fall 2013
 * 
 */

import java.util.Random;
import javax.swing.JLabel;

public class ATM extends Thread {

    private static final int MAX_PAUSE = 10;
    private static final int NUM_TRANSACTIONS = 1000;

    private Random pauseGenerator = new Random();

    private Account account;
    private int change;             // Amount of each transaction
    private JLabel info;            // Where to display description of transactions
    private int total = 0;

    // Store parameters and start running
    public ATM(Account anAccount, int aChange, JLabel aInfo) {
        
        account = anAccount;
        change = aChange;
        info = aInfo;

        start();
    }

    // Repeatedly withdraw "change" from account at bank.
    // This is effectively a deposit when "change" is negative.
    public void run() {

        for (int i = 0; i < NUM_TRANSACTIONS; i++) {

            account.changeBalance(change);

            total = total + change;
            info.setText("" + total);

            // demonstrate both with and without sleep
            //try {
            //    sleep(400);
            //}
            //catch (Exception e) {}
        }
    }
}